//
//  OJSDebugViewController.swift
//  OJASwiftKitDemo
//
//  Created by luxiaoming on 2016/12/7.
//  Copyright © 2016年 luxiaoming. All rights reserved.
//

import UIKit

private let kDebugViewControllerCellIdentifier = "kDebugViewControllerCellIdentifier"
public let kOJSUserDefaultsTestEnvironmentKey = "kOJSUserDefaultsTestEnvironmentKey"


class OJSDebugViewController: UITableViewController {
    lazy var hostSwitch: UISwitch = {
        let hostSwitch = UISwitch()
        hostSwitch.isOn = kOJSUserDefaults.bool(forKey: kOJSUserDefaultsTestEnvironmentKey)
        hostSwitch.addTarget(self, action: #selector(switchDebugEnvironment), for: .valueChanged)
        return hostSwitch
    }()
    
}

// MARK: - Lifecycle
extension OJSDebugViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        setupUI()
        setupNavigationBar()
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
}

// MARK: - PrivateMethod
private extension OJSDebugViewController {
    
    func setupUI() {
        self.tableView.register(UITableViewCell.classForCoder(), forCellReuseIdentifier: kDebugViewControllerCellIdentifier)
        
    }
    
    func setupNavigationBar() {
        self.navigationItem.rightBarButtonItem = UIBarButtonItem(title: "取消", style: .plain, target: self, action: #selector(dismissViewController))
        
        
        
    }
    
    @objc func dismissViewController() {
        self.dismiss(animated: true, completion: nil)
    }
 
    @objc func switchDebugEnvironment(sender: UISwitch) {
        kOJSUserDefaults.set(sender.isOn, forKey: kOJSUserDefaultsTestEnvironmentKey)
        kOJSUserDefaults.synchronize()
        
        abort()
    }
}


extension OJSDebugViewController {
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 2
    }
    
    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: kDebugViewControllerCellIdentifier, for: indexPath)
        if indexPath.row == 0 {
//            cell.textLabel?.text = "测试环境"
//            cell.accessoryView = hostSwitch
            cell.textLabel?.text = nil
            cell.accessoryView = nil
            
        }
        else if indexPath.row == 1 {
            cell.textLabel?.text = "清除推荐缓存"
            cell.accessoryView = nil
        }
        
        return cell
    }
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
    }
    
}
