//
//  OJSScrollViewExtension.swift
//  OJASwiftKitDemo
//
//  Created by luxiaoming on 2017/8/12.
//  Copyright © 2017年 luxiaoming. All rights reserved.
//

import Foundation
import UIKit


extension UIScrollView {
    
    
    /// 滑动到顶部，注意：没有delay == 0时会立即执行，但contentSize可能会不准
    open func scrollToTop(afterDelay delay: Double = 0.1, animated: Bool = true) {
        let topRect = CGRect(x: 0, y: 0, width: self.frame.width, height: 1)
        if delay > Double.leastNormalMagnitude {
            Delay(delay) {
                self.scrollRectToVisible(topRect, animated: animated)
            }
        } else {
            self.scrollRectToVisible(topRect, animated: animated)
        }
        
        
    }
    
    /// 滑动到底部，注意：没有delay == 0时会立即执行，但contentSize可能会不准
    open func scrollToBottom(afterDelay delay: Double = 0.1, animated: Bool = true) {
        let bottomRect = CGRect(x: 0, y: self.contentSize.height - 1, width: self.frame.width, height: 1) //注意，如果目标rect的位置超出contentSize，就什么都不会执行
        if delay > Double.leastNormalMagnitude {
            Delay(delay) {
                self.scrollRectToVisible(bottomRect, animated: animated)
            }
        } else {
            self.scrollRectToVisible(bottomRect, animated: animated)
        }
        
    }
    
}
