//
//  OJSTabBarController.swift
//  OJASwiftKitDemo
//
//  Created by luxiaoming on 2016/11/19.
//  Copyright © 2016年 luxiaoming. All rights reserved.
//

import UIKit

open class OJSTabBarController: UITabBarController {

    open var topBaseViewController: OJSViewController? {

        if let nav = self.selectedViewController as? OJSNavigationController {
            return nav.topBaseViewController
        } else {
            return self.selectedViewController as? OJSViewController
        }
    }
    
    open var currentNavigationController: OJSNavigationController? {
        return self.selectedViewController as? OJSNavigationController
    }
    
    
    
    
    
}

// MARK: - Lifecycle
extension OJSTabBarController {
    
    open override func viewDidLoad() {
        super.viewDidLoad()
        
    }
    
    open override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
}



// MARK: - StatusBar
extension OJSTabBarController {
    
    open override var preferredStatusBarStyle: UIStatusBarStyle {
        if let viewController = self.selectedViewController {
            return viewController.preferredStatusBarStyle
        } else {
            return .default
        }
    }
    
    open override var prefersStatusBarHidden: Bool {
        if let viewController = self.selectedViewController {
            return viewController.prefersStatusBarHidden
        } else {
            return false
        }
    }
}



// MARK: - Rotation
extension OJSTabBarController {
    
    //这里，如果selectedViewController是navigationController，因为navigationController也是返回它的topViewController的状态，所以最终还是各个viewController自己来控制自己的状态
    
    open override var shouldAutorotate: Bool {
        if let tempViewController = self.selectedViewController {
            return tempViewController.shouldAutorotate
        } else {
            return false
        }
    }
    
    open override var supportedInterfaceOrientations: UIInterfaceOrientationMask {
        if let tempViewController = self.selectedViewController {
            return tempViewController.supportedInterfaceOrientations
        } else {
            return UIInterfaceOrientationMask.portrait
        }
    }
    
    
    open override var preferredInterfaceOrientationForPresentation: UIInterfaceOrientation {
        if let tempViewController = self.selectedViewController {
            return tempViewController.preferredInterfaceOrientationForPresentation
        } else {
            return UIInterfaceOrientation.portrait
        }
    }
}
