//
//  OJSTableViewController.swift
//  OJASwiftKitDemo
//
//  Created by luxiaoming on 2016/11/21.
//  Copyright © 2016年 luxiaoming. All rights reserved.
//

import UIKit

open class OJSTableViewController: OJSViewController {
    
    open var tableView: UITableView!
    
    fileprivate var tableViewStyle: UITableViewStyle = .plain
    
    public convenience init(style: UITableViewStyle) {
        self.init()
        self.tableViewStyle = style
    }

}

// MARK: - Lifecycle
extension OJSTableViewController {
    
    open override func viewDidLoad() {
        super.viewDidLoad()
        
        setupBaseTableView()
    }
    
    open override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
}


// MARK: - PrivateMethod
private extension OJSTableViewController {
    
    func setupBaseTableView() {

        self.tableView = UITableView(frame: CGRect.zero, style: self.tableViewStyle)
        self.tableView.separatorStyle = .singleLine
        self.tableView.separatorInset = .zero
        self.tableView.keyboardDismissMode = .onDrag
        self.view.addSubview(self.tableView)
        
        self.tableView.translatesAutoresizingMaskIntoConstraints = false//注意！！！这一句很关键，如果要像下面这样手写autolayout，就必须设置，否则肯定会约束冲突
        self.view.addConstraint(NSLayoutConstraint(item: self.tableView, attribute: .leading, relatedBy: .equal, toItem: self.view, attribute: .leading, multiplier: 1, constant: 0))
        self.view.addConstraint(NSLayoutConstraint(item: self.tableView, attribute: .trailing, relatedBy: .equal, toItem: self.view, attribute: .trailing, multiplier: 1, constant: 0))
        self.view.addConstraint(NSLayoutConstraint(item: self.tableView, attribute: .top, relatedBy: .equal, toItem: self.view, attribute: .top, multiplier: 1, constant: 0))
        self.view.addConstraint(NSLayoutConstraint(item: self.tableView, attribute: .bottom, relatedBy: .equal, toItem: self.view, attribute: .bottom, multiplier: 1, constant: 0))
        
    }
    
}

